<?php
header('Content-Type: text/html; charset=UTF-8');
// Функция, производящая регистрацию
function register($login, $email, $password)
{
	// Все POST-параметры, которые надо отправить
	$post = array(
		'agree' => 1, // Да, мы согласны с правилами ;-)
		'profile_is_female' => 0, // Укажем пол
		'profile_nick_name' => $login, // Наш логин
		'user_email' => $email, // email
		'user_password' => $password, // пароль
		'user_password_repeat' => $password,// повторим пароль
	);

	// Особая, curl-ная магия
	$ch = curl_init(); // Инициализируем сессию
	curl_setopt($ch, CURLOPT_URL,"http://toodoo.ru/account/signup"); // задаем адрес обработчика формы
	curl_setopt($ch, CURLOPT_POST, 1); // Указываем, что нам нужно отправить POST-запрос
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Передаем POST-параметры
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Результат нам нужно вернуть в переменную, а не на экран
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // Переходить по редиректам
	// Генерируем временный файл для cookies, чтобы они не терялись между запросами-редиректами
	$temp = tempnam('.', '__');
	curl_setopt($ch, CURLOPT_COOKIEJAR, $temp);
	unlink($temp);
	
	// Запускаем запрос!
	$result = curl_exec($ch);
	
	curl_close ($ch); // Закрываем сессию
	
	// Проверяем на успешность регистрации
	if(strstr($result, 'Поздравляем, ты успешно зарегистрировался в toodoo!'))
	{
		return true;
	}
	else
	{
		return false;
	}
}

// Параметры регистрации. Их можно задавать руками, или считывать из файла - на ваше усмотрение.
$login = 'autoreg-test';
$email = 'autoreg-test@yandex.ru';
$password = '*****';
// Данные для авторизации на почтовом сервере
$pop3_server = 'pop.yandex.ru';
$pop3_login = 'autoreg-test';
$pop3_password = '**********';

$step = $_GET['step']; // Текущая стадия

// Выводим, что мы будем регать
echo "Логин: $login, пароль: $password, email: $email<br/>";

// Начало регистрации
if($step == 'reg')
{
	// Регаем
	if(register($login, $email, $password))
	{
		echo 'Успешно зарегистрирован';
		echo '<br><a href="'.basename(__FILE__).'?step=confirm">подтверждение по email</a>';
	}
	else
	{
		echo '<b>Ошибка регистрации</b>';
		echo '<br><a href="'.basename(__FILE__).'">Еще раз</a>';
	}
}
// Завершение регистрации (подтверждение)
else if($step == 'confirm')
{
	// Подключаем библиотеку для работы с POP3
	require('PEAR/POP3.php');
	
	// Создаем POP3-клиент
	$api = new Net_POP3();
	
	// Подключаемся к почтовому серверу
	if($api=>connect($pop3_server , 110 ) !== true)
	{
		echo 'Не удалось подключиться к серверу';
		echo '<br><a href="'.basename(__FILE__).'?step=confirm">Еще раз</a>';
		die();
	}
	
	// Авторизуемся
	if($api->login($pop3_login , $pop3_password ) !== true)
	{
		echo 'Не удалось авторизоваться';
		echo '<br><a href="'.basename(__FILE__).'?step=confirm">Еще раз</a>';
		die();
	}
	
	$list = $api->getListing(); // Получаем список писем в ящике
	
	// Ищем нужное письмо - скачиваем заголовки поочередно для всех писем и проверяем адрес отправителя
	foreach($list as $item)
	{
		$headers = $api->getParsedHeaders($item['msg_id']); // Скачиваем заголовки
		
		// Если отправитель совпадает с нужним нам, то приступаем к обработке
		if(strstr($headers['From'], 'toodoo.ru'))
		{
			$body = $api->getBody($item['msg_id']); // Скачиваем все письмо
			
			// Вытаскиваем уникальную ссылку
			preg_match('#http://toodoo.ru/confirm/contact\?code=\S+#i', $body, $matches);
			
			// Особая, curl-ная магия
			$ch = curl_init(); // Инициализируем сессию
			curl_setopt($ch, CURLOPT_URL,$matches[0]); // задаем адрес страницы подтверждения
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Результат нам нужно вернуть в переменную, а не на экран
			curl_setopt($ch. CURLOPT_FOLLOWLOCATION, 1); // Переходить по редиректам
			$result = curl_exec($ch); // Выполняем запрос
			
			// Мы, часом, еще не подтвердили?
			if(strstr($result, 'Видимо адрес по этой ссылке был уже подтвержден.'))
			{
				echo 'Что-то пошло не так, либо аккаунт уже подтвержден.';
				echo '<br><a href="'.basename(__FILE__).'?step=confirm">Еще раз</a>';
				break;
			}
			
			// У toodoo.ru требуется отправить дополнительную форму о том, что мы действительно подтверждаем регистрацию
			
			// Добываем уникальный ключ
			preg_match('#<input type="hidden" name="code" value="([^"]+)">#', $result, $matches);
			
			// Формируем поля запроса
			$post = array(
				'code'	=> $matches[1],
				'agree'	=> 'Добавить',
			);
			
			// Отправляем форму
			curl_setopt($ch, CURLOPT_URL,"http://toodoo.ru/confirm/contact"); // задаем адрес обработчика формы
			curl_setopt($ch, CURLOPT_POST, 1); // Указываем, что нам нужно отправить POST-запрос
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Передаем POST-параметры
			$result = curl_exec($ch); // Выполняем запрос
			
			curl_close ($ch); // Закрываем сессию
			
			// Мавр сделал свое дело, мавр может уходить.
			echo 'Аккаунт успешно подтвержден!';
			break;
		}
	}
}
else
{
	echo '<br><a href="'.basename(__FILE__).'?step=reg">Начать регистрацию</a>';
}

// Все!  ;-)
?>